﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp86
{
    public partial class Form1 : Form
    {
        public int counter = 15;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Student s = new Student();
            s.Age = 20;
            s.Name = "George";
            s.AM = "P20123";
            IFormatter formatter = new BinaryFormatter();
            Stream stream = 
                new FileStream("student1.ser", FileMode.OpenOrCreate, FileAccess.Write);
            formatter.Serialize(stream, s);
            stream.Close();
            MessageBox.Show("Student is serialized!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            IFormatter formatter = new BinaryFormatter();
            Stream stream = new FileStream("student1.ser", FileMode.Open, FileAccess.Read);
            Student s2 = (Student)formatter.Deserialize(stream);
            stream.Close();
            MessageBox.Show(s2.AM + "," + s2.Name + "," + s2.Age);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }
        int a = 0;
        private void timer1_Tick(object sender, EventArgs e)
        {
            a += 1;
            
            progressBar1.Value += progressBar1.Step;
            label1.Text = progressBar1.Value.ToString();
            if (a == 10)
            {
                timer1.Enabled = false;
                MessageBox.Show("Done!");
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            comboBox1.Items.Clear();
            for(int i = 0; i < Application.OpenForms.Count; i++)
            {
                comboBox1.Items.Add(Application.OpenForms[i].Name);
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            new Form2().Show();
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (Application.OpenForms[0].GetType() == typeof(Form1))
                MessageBox.Show(((Form1)Application.OpenForms[0]).counter.ToString());
        }
    }
}
